package xyz.lychee.lagfixer.libs.adventure.resource;

import java.util.List;
import java.util.Objects;
import xyz.lychee.lagfixer.libs.adventure.builder.AbstractBuilder;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.examination.Examinable;

public interface ResourcePackRequest extends Examinable, ResourcePackRequestLike {
   static @NotNull ResourcePackRequest addingRequest(final @NotNull ResourcePackInfoLike first, final @NotNull ResourcePackInfoLike... others) {
      return (ResourcePackRequest)resourcePackRequest().packs(first, others).replace(false).build();
   }

   @NotNull
   static @NotNull Builder resourcePackRequest() {
      return new ResourcePackRequestImpl.BuilderImpl();
   }

   @NotNull
   static @NotNull Builder resourcePackRequest(final @NotNull ResourcePackRequest existing) {
      return new ResourcePackRequestImpl.BuilderImpl((ResourcePackRequest)Objects.requireNonNull(existing, "existing"));
   }

   @NotNull List<ResourcePackInfo> packs();

   @NotNull ResourcePackRequest packs(final @NotNull Iterable<? extends ResourcePackInfoLike> packs);

   @NotNull ResourcePackCallback callback();

   @NotNull ResourcePackRequest callback(final @NotNull ResourcePackCallback cb);

   boolean replace();

   @NotNull ResourcePackRequest replace(final boolean replace);

   boolean required();

   @Nullable Component prompt();

   default @NotNull ResourcePackRequest asResourcePackRequest() {
      return this;
   }

   public interface Builder extends AbstractBuilder<ResourcePackRequest>, ResourcePackRequestLike {
      @Contract("_, _ -> this")
      @NotNull
      @NotNull Builder packs(final @NotNull ResourcePackInfoLike first, final @NotNull ResourcePackInfoLike... others);

      @Contract("_ -> this")
      @NotNull
      @NotNull Builder packs(final @NotNull Iterable<? extends ResourcePackInfoLike> packs);

      @Contract("_ -> this")
      @NotNull
      @NotNull Builder callback(final @NotNull ResourcePackCallback cb);

      @Contract("_ -> this")
      @NotNull
      @NotNull Builder replace(final boolean replace);

      @Contract("_ -> this")
      @NotNull
      @NotNull Builder required(final boolean required);

      @Contract("_ -> this")
      @NotNull
      @NotNull Builder prompt(final @Nullable Component prompt);

      default @NotNull ResourcePackRequest asResourcePackRequest() {
         return (ResourcePackRequest)this.build();
      }
   }
}
